unit Main;

interface

uses
  Windows, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, ComCtrls, FormHints;

type
  TForm1 = class(TForm)
    TestPanel: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    GroupBox1: TGroupBox;
    FormHints: TFormHints;
    GroupBox2: TGroupBox;
    ActiveBox: TCheckBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    RoundedBox: TCheckBox;
    ShowArrowBox: TCheckBox;
    ShowShadowBox: TCheckBox;
    Label8: TLabel;
    AlignmentBox: TComboBox;
    Label9: TLabel;
    RateEdit: TEdit;
    TransparentBox: TCheckBox;
    BitBtn1: TBitBtn;
    DirectionBox: TComboBox;
    BackgroundBox: TPanel;
    BorderBox: TPanel;
    ShadowBox: TPanel;
    FontDialog: TFontDialog;
    ColorDialog: TColorDialog;
    TestEdit: TRichEdit;
    procedure FormShow(Sender: TObject);
    procedure TestEditChange(Sender: TObject);
    procedure ActiveBoxClick(Sender: TObject);
    procedure BackgroundBoxClick(Sender: TObject);
    procedure BorderBoxClick(Sender: TObject);
    procedure ShadowBoxClick(Sender: TObject);
    procedure DirectionBoxChange(Sender: TObject);
    procedure AlignmentBoxChange(Sender: TObject);
    procedure RoundedBoxClick(Sender: TObject);
    procedure ShowArrowBoxClick(Sender: TObject);
    procedure ShowShadowBoxClick(Sender: TObject);
    procedure TransparentBoxClick(Sender: TObject);
    procedure RateEditChange(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormShow(Sender: TObject);
var
  St: String;
begin
  Application.HintHidePause := 15000;

  ActiveBox.Checked := FormHints.Active;
  BackgroundBox.Color := FormHints.ColorBackground;
  BackgroundBox.Font.Color := FormHints.ColorBackground xor $FFFFFF;
  BorderBox.Color := FormHints.ColorBorder;
  BorderBox.Font.Color := FormHints.ColorBorder xor $FFFFFF;
  DirectionBox.ItemIndex := Integer(FormHints.Direction);
  AlignmentBox.ItemIndex := Integer(FormHints.TextAlignment);
  RoundedBox.Checked := FormHints.Rounded;
  ShowArrowBox.Checked := FormHints.ShowArrow;
  ShowShadowBox.Checked := FormHints.ShowShadow;
  TransparentBox.Checked := FormHints.Transparent;

  St := TestEdit.Text;
  Delete(St, Length(St) - 1, 2);
  TestPanel.Hint := St;
end;

procedure TForm1.TestEditChange(Sender: TObject);
begin
  TestPanel.Hint := TestEdit.Text;
end;

procedure TForm1.ActiveBoxClick(Sender: TObject);
begin
  FormHints.Active := ActiveBox.Checked;
end;

procedure TForm1.BackgroundBoxClick(Sender: TObject);
begin
  ColorDialog.Color := FormHints.ColorBackground;
  if ColorDialog.Execute then
   begin
    FormHints.ColorBackground := ColorDialog.Color;
    BackgroundBox.Color := ColorDialog.Color;
    BackgroundBox.Font.Color := FormHints.ColorBackground xor $FFFFFF;    
   end;
end;

procedure TForm1.BorderBoxClick(Sender: TObject);
begin
  ColorDialog.Color := FormHints.ColorBorder;
  if ColorDialog.Execute then
   begin
    FormHints.ColorBorder := ColorDialog.Color;
    BorderBox.Color := ColorDialog.Color;
    BorderBox.Font.Color := FormHints.ColorBorder xor $FFFFFF;
   end;
end;

procedure TForm1.ShadowBoxClick(Sender: TObject);
begin
  ColorDialog.Color := FormHints.ColorShadow;
  if ColorDialog.Execute then
   begin
    FormHints.ColorShadow := ColorDialog.Color;
    ShadowBox.Color := ColorDialog.Color;
   end;
end;

procedure TForm1.DirectionBoxChange(Sender: TObject);
begin
  FormHints.Direction := TfhHintDirection(DirectionBox.ItemIndex);
end;

procedure TForm1.AlignmentBoxChange(Sender: TObject);
begin
  FormHints.TextAlignment := TfhTextAlignment(AlignmentBox.ItemIndex);
end;

procedure TForm1.RoundedBoxClick(Sender: TObject);
begin
  FormHints.Rounded := RoundedBox.Checked;
end;

procedure TForm1.ShowArrowBoxClick(Sender: TObject);
begin
  FormHints.ShowArrow := ShowArrowBox.Checked;
end;

procedure TForm1.ShowShadowBoxClick(Sender: TObject);
begin
  FormHints.ShowShadow := ShowShadowBox.Checked;
end;

procedure TForm1.TransparentBoxClick(Sender: TObject);
begin
  FormHints.Transparent := TransparentBox.Checked;
end;

procedure TForm1.RateEditChange(Sender: TObject);
begin
  FormHints.TransparencyRate := StrToIntDef(RateEdit.Text, 0);
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  FontDialog.Font := FormHints.Font;
  if FontDialog.Execute then
   FormHints.Font := FontDialog.Font;
end;

end.
